﻿using System;

namespace Cfg.Attributes
{
    /// <summary>
    /// Affects only property with type of Path
    /// </summary>
    [AttributeUsage(AttributeTargets.Property, AllowMultiple = false)]
    public class PathAttribute : Attribute
	{
	    public bool CreateIfNotExists { get; set; }
		public bool ThrowIfNotExists { get; set; }
        public bool IsFilePath { get; set; }

        public PathAttribute(bool createIfNotExists = true, bool throwIfNotExists = true)
        {
            CreateIfNotExists = createIfNotExists;
	        ThrowIfNotExists = throwIfNotExists;
        }
	}
}
