﻿using System.Runtime.Remoting.Messaging;
using System.Web;

namespace Cfg.Proxies
{
    public static class WebSafeCallContext
    {
        public static object GetData(string name)
        {
            var ctx = HttpContext.Current;
            return ctx == null 
                ? CallContext.GetData(name) 
                : ctx.Items[name];
        }

        public static void SetData(string name, object value)
        {
            var ctx = HttpContext.Current;
            if (ctx == null)
            {
                CallContext.SetData(name, value);
            }
            else
            {
                ctx.Items[name] = value;
            }
        }

        public static void FreeNamedDataSlot(string name)
        {
            var ctx = HttpContext.Current;
            if (ctx == null)
            {
                CallContext.FreeNamedDataSlot(name);
            }
            else
            {
                ctx.Items.Remove(name);
            }
        }
    }
}